Package org.springframework.scheduling.concurrent

# Class ThreadPoolExecutorFactoryBean

java.lang.Object
org.springframework.util.CustomizableThreadCreator
org.springframework.scheduling.concurrent.CustomizableThreadFactory
org.springframework.scheduling.concurrent.ExecutorConfigurationSupport
org.springframework.scheduling.concurrent.ThreadPoolExecutorFactoryBean

All Implemented Interfaces:
  `Serializable`, `ThreadFactory`, `EventListener`, `org.springframework.beans.factory.Aware`, `org.springframework.beans.factory.BeanNameAware`, `org.springframework.beans.factory.DisposableBean`, `org.springframework.beans.factory.FactoryBean<ExecutorService>`, `org.springframework.beans.factory.InitializingBean`, `ApplicationContextAware`, `ApplicationListener<ContextClosedEvent>`, `Lifecycle`, `Phased`, `SmartLifecycle`

public class ThreadPoolExecutorFactoryBean extends ExecutorConfigurationSupport implements org.springframework.beans.factory.FactoryBean<ExecutorService>
JavaBean that allows for configuring a `ThreadPoolExecutor` in bean style (through its "corePoolSize", "maxPoolSize", "keepAliveSeconds", "queueCapacity" properties) and exposing it as a bean reference of its native `ExecutorService` type.

The default configuration is a core pool size of 1, with unlimited max pool size and unlimited queue capacity. This is roughly equivalent to `Executors.newSingleThreadExecutor()`, sharing a single thread for all tasks. Setting `"queueCapacity"` to 0 mimics `Executors.newCachedThreadPool()`, with immediate scaling of threads in the pool to a potentially very high number. Consider also setting a `"maxPoolSize"` at that point, as well as possibly a higher `"corePoolSize"` (see also the `"allowCoreThreadTimeOut"` mode of scaling).

For an alternative, you may set up a `ThreadPoolExecutor` instance directly using constructor injection, or use a factory method definition that points to the `Executors` class. This is strongly recommended in particular for common `@Bean` methods in configuration classes, where this `FactoryBean` variant would force you to return the `FactoryBean` type instead of the actual `Executor` type.

If you need a timing-based `ScheduledExecutorService` instead, consider `ScheduledExecutorFactoryBean`.

Since:
  3.0
Author:
  Juergen Hoeller
See Also:
  - `ExecutorService`
  - `Executors`
  - `ThreadPoolExecutor`
  - Serialized Form

## Field Summary

### Fields inherited from class org.springframework.scheduling.concurrent.ExecutorConfigurationSupport

`DEFAULT_PHASE, logger`

### Fields inherited from interface org.springframework.beans.factory.FactoryBean

`OBJECT_TYPE_ATTRIBUTE`

## Constructor Summary

Constructors
Constructor
Description
`ThreadPoolExecutorFactoryBean()`

## Method Summary

Modifier and Type
Method
Description
`protected ThreadPoolExecutor`
`createExecutor(int corePoolSize, int maxPoolSize, int keepAliveSeconds, BlockingQueue<Runnable> queue, ThreadFactory threadFactory, RejectedExecutionHandler rejectedExecutionHandler)`
Create a new instance of `ThreadPoolExecutor` or a subclass thereof.
`protected BlockingQueue<Runnable>`
`createQueue(int queueCapacity)`
Create the BlockingQueue to use for the ThreadPoolExecutor.
`ExecutorService`
`getObject()`
`Class<? extends ExecutorService>`
`getObjectType()`
`protected ExecutorService`
`initializeExecutor(ThreadFactory threadFactory, RejectedExecutionHandler rejectedExecutionHandler)`
Create the target `ExecutorService` instance.
`protected void`
`initiateEarlyShutdown()`
Early shutdown signal: do not trigger further tasks, let existing tasks complete before hitting the actual destruction step in the `ExecutorConfigurationSupport.shutdown()` method.
`boolean`
`isSingleton()`
`void`
`setAllowCoreThreadTimeOut(boolean allowCoreThreadTimeOut)`
Specify whether to allow core threads to time out.
`void`
`setCorePoolSize(int corePoolSize)`
Set the ThreadPoolExecutor's core pool size.
`void`
`setExposeUnconfigurableExecutor(boolean exposeUnconfigurableExecutor)`
Specify whether this FactoryBean should expose an unconfigurable decorator for the created executor.
`void`
`setKeepAliveSeconds(int keepAliveSeconds)`
Set the ThreadPoolExecutor's keep-alive seconds.
`void`
`setMaxPoolSize(int maxPoolSize)`
Set the ThreadPoolExecutor's maximum pool size.
`void`
`setPrestartAllCoreThreads(boolean prestartAllCoreThreads)`
Specify whether to start all core threads, causing them to idly wait for work.
`void`
`setQueueCapacity(int queueCapacity)`
Set the capacity for the ThreadPoolExecutor's BlockingQueue.
`void`
`setStrictEarlyShutdown(boolean defaultEarlyShutdown)`
Specify whether to initiate an early shutdown signal on context close, disposing all idle threads and rejecting further task submissions.

### Methods inherited from class org.springframework.scheduling.concurrent.ExecutorConfigurationSupport

`afterExecute, afterPropertiesSet, beforeExecute, cancelRemainingTask, destroy, getPhase, initialize, initiateShutdown, isRunning, onApplicationEvent, setAcceptTasksAfterContextClose, setApplicationContext, setAwaitTerminationMillis, setAwaitTerminationSeconds, setBeanName, setPhase, setRejectedExecutionHandler, setThreadFactory, setThreadNamePrefix, setVirtualThreads, setWaitForTasksToCompleteOnShutdown, shutdown, start, stop, stop`

### Methods inherited from class org.springframework.scheduling.concurrent.CustomizableThreadFactory

`newThread`

### Methods inherited from class org.springframework.util.CustomizableThreadCreator

`createThread, getDefaultThreadNamePrefix, getThreadGroup, getThreadNamePrefix, getThreadPriority, isDaemon, nextThreadName, setDaemon, setThreadGroup, setThreadGroupName, setThreadPriority`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.springframework.context.ApplicationListener

`supportsAsyncExecution`

### Methods inherited from interface org.springframework.context.SmartLifecycle

`isAutoStartup`

## Constructor Details

### ThreadPoolExecutorFactoryBean

public ThreadPoolExecutorFactoryBean()

## Method Details

### setCorePoolSize

public void setCorePoolSize(int corePoolSize)
Set the ThreadPoolExecutor's core pool size. Default is 1.

### setMaxPoolSize

public void setMaxPoolSize(int maxPoolSize)
Set the ThreadPoolExecutor's maximum pool size. Default is `Integer.MAX_VALUE`.

### setKeepAliveSeconds

public void setKeepAliveSeconds(int keepAliveSeconds)
Set the ThreadPoolExecutor's keep-alive seconds. Default is 60.

### setQueueCapacity

public void setQueueCapacity(int queueCapacity)
Set the capacity for the ThreadPoolExecutor's BlockingQueue. Default is `Integer.MAX_VALUE`.

Any positive value will lead to a LinkedBlockingQueue instance; any other value will lead to a SynchronousQueue instance.

See Also:
  - `LinkedBlockingQueue`
  - `SynchronousQueue`

### setAllowCoreThreadTimeOut

public void setAllowCoreThreadTimeOut(boolean allowCoreThreadTimeOut)
Specify whether to allow core threads to time out. This enables dynamic growing and shrinking even in combination with a non-zero queue (since the max pool size will only grow once the queue is full).

Default is "false".

See Also:
  - `ThreadPoolExecutor.allowCoreThreadTimeOut(boolean)`

### setPrestartAllCoreThreads

public void setPrestartAllCoreThreads(boolean prestartAllCoreThreads)
Specify whether to start all core threads, causing them to idly wait for work.

Default is "false".

Since:
  5.3.14
See Also:
  - `ThreadPoolExecutor.prestartAllCoreThreads()`

### setStrictEarlyShutdown

public void setStrictEarlyShutdown(boolean defaultEarlyShutdown)
Specify whether to initiate an early shutdown signal on context close, disposing all idle threads and rejecting further task submissions.

Default is "false". See `ThreadPoolTaskExecutor.setStrictEarlyShutdown(boolean)` for details.

Since:
  6.1.4
See Also:
  - `ExecutorConfigurationSupport.initiateShutdown()`

### setExposeUnconfigurableExecutor

public void setExposeUnconfigurableExecutor(boolean exposeUnconfigurableExecutor)
Specify whether this FactoryBean should expose an unconfigurable decorator for the created executor.

Default is "false", exposing the raw executor as bean reference. Switch this flag to "true" to strictly prevent clients from modifying the executor's configuration.

See Also:
  - `Executors.unconfigurableExecutorService(java.util.concurrent.ExecutorService)`

### initializeExecutor

protected ExecutorService initializeExecutor(ThreadFactory threadFactory, RejectedExecutionHandler rejectedExecutionHandler)
Description copied from class: `ExecutorConfigurationSupport`
Create the target `ExecutorService` instance. Called by `afterPropertiesSet`.

Specified by:
  `initializeExecutor` in class `ExecutorConfigurationSupport`
Parameters:
  `threadFactory` - the ThreadFactory to use
  `rejectedExecutionHandler` - the RejectedExecutionHandler to use
Returns:
  a new ExecutorService instance
See Also:
  - `ExecutorConfigurationSupport.afterPropertiesSet()`

### createExecutor

protected ThreadPoolExecutor createExecutor(int corePoolSize, int maxPoolSize, int keepAliveSeconds, BlockingQueue<Runnable> queue, ThreadFactory threadFactory, RejectedExecutionHandler rejectedExecutionHandler)
Create a new instance of `ThreadPoolExecutor` or a subclass thereof.

The default implementation creates a standard `ThreadPoolExecutor`. Can be overridden to provide custom `ThreadPoolExecutor` subclasses.

Parameters:
  `corePoolSize` - the specified core pool size
  `maxPoolSize` - the specified maximum pool size
  `keepAliveSeconds` - the specified keep-alive time in seconds
  `queue` - the BlockingQueue to use
  `threadFactory` - the ThreadFactory to use
  `rejectedExecutionHandler` - the RejectedExecutionHandler to use
Returns:
  a new ThreadPoolExecutor instance
See Also:
  - `ExecutorConfigurationSupport.afterPropertiesSet()`

### createQueue

protected BlockingQueue<Runnable> createQueue(int queueCapacity)
Create the BlockingQueue to use for the ThreadPoolExecutor.

A LinkedBlockingQueue instance will be created for a positive capacity value; a SynchronousQueue else.

Parameters:
  `queueCapacity` - the specified queue capacity
Returns:
  the BlockingQueue instance
See Also:
  - `LinkedBlockingQueue`
  - `SynchronousQueue`

### initiateEarlyShutdown

protected void initiateEarlyShutdown()
Description copied from class: `ExecutorConfigurationSupport`
Early shutdown signal: do not trigger further tasks, let existing tasks complete before hitting the actual destruction step in the `ExecutorConfigurationSupport.shutdown()` method. This goes along with a `coordinated lifecycle stop phase`.

Called from `ExecutorConfigurationSupport.onApplicationEvent(ContextClosedEvent)` if no indications for a late shutdown have been determined, that is, if the `"acceptTasksAfterContextClose` and `"waitForTasksToCompleteOnShutdown"` flags have not been set.

The default implementation calls `ExecutorConfigurationSupport.initiateShutdown()`.

Overrides:
  `initiateEarlyShutdown` in class `ExecutorConfigurationSupport`
See Also:
  - `ExecutorConfigurationSupport.initiateShutdown()`

### getObject

@Nullable public ExecutorService getObject()

Specified by:
  `getObject` in interface `org.springframework.beans.factory.FactoryBean<ExecutorService>`

### getObjectType

public Class<? extends ExecutorService> getObjectType()

Specified by:
  `getObjectType` in interface `org.springframework.beans.factory.FactoryBean<ExecutorService>`

### isSingleton

public boolean isSingleton()

Specified by:
  `isSingleton` in interface `org.springframework.beans.factory.FactoryBean<ExecutorService>`